The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::TwoPole Class Reference

STK two-pole filter class. More...

`#include <TwoPole.h>`

Inheritance diagram for stk::TwoPole:

List of all members.

## Public Member Functions
| TwoPole (void)
| Default constructor creates a second-order pass-through filter.
| ~TwoPole ()
| Class destructor.
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.
void | setB0 (StkFloat b0)
| Set the b[0] coefficient value.
void | setA1 (StkFloat a1)
| Set the a[1] coefficient value.
void | setA2 (StkFloat a2)
| Set the a[2] coefficient value.
void | setCoefficients (StkFloat b0, StkFloat a1, StkFloat a2, bool clearState=false)
| Set all filter coefficients.
void | setResonance (StkFloat frequency, StkFloat radius, bool normalize=false)
| Sets the filter coefficients for a resonance at frequency (in Hz).
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

## Detailed Description

STK two-pole filter class.

This class implements a two-pole digital filter. A method is provided for creating a resonance in the frequency response while maintaining a nearly constant filter gain.

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Member Function Documentation

void stk::TwoPole::setResonance | ( | StkFloat | frequency,
|  | StkFloat | radius,
|  | bool | normalize = `false` |
| ) |  |  |

Sets the filter coefficients for a resonance at frequency (in Hz).

This method determines the filter coefficients corresponding to two complex-conjugate poles with the given frequency (in Hz) and radius from the z-plane origin. If normalize is true, the coefficients are then normalized to produce unity gain at frequency (the actual maximum filter gain tends to be slightly greater than unity when radius is not close to one). The resulting filter frequency response has a resonance at the given frequency. The closer the poles are to the unit-circle (radius close to one), the narrower the resulting resonance width. An unstable filter will result for radius >= 1.0. The frequency value should be between zero and half the sample rate. For a better resonance filter, use a BiQuad filter.

See also:
  BiQuad filter class

StkFrames & stk::TwoPole::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

    00107 {
    00108 #if defined(_STK_DEBUG_)
    00109   if ( channel >= frames.channels() ) {
    00110     oStream_ << "TwoPole::tick(): channel and StkFrames arguments are incompatible!";
    00111     handleError( StkError::FUNCTION_ARGUMENT );
    00112   }
    00113 #endif
    00114
    00115   StkFloat *samples = &frames[channel];
    00116   unsigned int hop = frames.channels();
    00117   for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
    00118     inputs_[0] = gain_ * *samples;
    00119     *samples = b_[0] * inputs_[0] - a_[1] * outputs_[1] - a_[2] * outputs_[2];
    00120     outputs_[2] = outputs_[1];
    00121     outputs_[1] = *samples;
    00122   }
    00123
    00124   lastFrame_[0] = outputs_[1];
    00125   return frames;
    00126 }

StkFrames & stk::TwoPole::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0` |
| ) |  |  | `[inline]`

Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

    00129 {
    00130 #if defined(_STK_DEBUG_)
    00131   if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
    00132     oStream_ << "TwoPole::tick(): channel and StkFrames arguments are incompatible!";
    00133     handleError( StkError::FUNCTION_ARGUMENT );
    00134   }
    00135 #endif
    00136
    00137   StkFloat *iSamples = &iFrames[iChannel];
    00138   StkFloat *oSamples = &oFrames[oChannel];
    00139   unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
    00140   for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop ) {
    00141     inputs_[0] = gain_ * *iSamples;
    00142     *oSamples = b_[0] * inputs_[0] - a_[1] * outputs_[1] - a_[2] * outputs_[2];
    00143     outputs_[2] = outputs_[1];
    00144     outputs_[1] = *oSamples;
    00145   }
    00146
    00147   lastFrame_[0] = outputs_[1];
    00148   return iFrames;
    00149 }

The documentation for this class was generated from the following file:

- TwoPole.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.